Data Table

The primary objective of the What-If Analysis Data Table is to display calculation results under different inputs.

SpreadJS add the function SJS.TABLE to get the What-If Analysis Data Table results. The SJS.TABLE function simulates inputting the value from inputs into input_cell , and then retrieves the value from result reference as the SJS.TABLE function result. Argument Description result_reference The cell location to retrieve the value. When all inputs are rows, it can be a range of 1 row and multiple columns. vice versa. inputs The values to input into input_cell. It can be a reference, an array, or a value. input_cell The cell to input the value. Must be a cell reference. SJS.TABLE can completely cover traditional Data Table Scenario Traditional Data Table Use SJS.TABLE one-variable data table Create DataTable A2:C10with column cell reference A2 B3: =SJS.TABLE(B2:C2,A3:A10,A2) one-variable data table Create DataTable A2:H5with row cell reference A2 B3: =SJS.TABLE(A3:A5,B2:H2,A2) two-variable data table Create DataTable A2:H5 with column cellreference A1 and row cell reference B1 B3: =SJS.TABLE(A2,B2:H2,B1,A3:A5,A1) The What-If Analysis Data Table from Excel file will be transformed to SJS.TABLE function formula when importing. When exporting to Excel, it attempts to convert to an Excel data table; if this fails, the formulas will be preserved. SJS.TABLE is flexible SJS.TABLE can use the various input SJS.TABLE can use as the function parameter
var spread; window.onload = function () { spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss")); initSpread(spread); }; function isSJSFile(file) { var fileName = file.name.toLowerCase(); return fileName.endsWith('.sjs'); } function initSpread(spread) { var statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(document.getElementById('statusBar')); statusBar.bind(spread); spread.fromJSON(datatable); // imported from datatable.js // Import file document.getElementById("importBtn").addEventListener('click', function() { document.getElementById("importFile").click(); }); document.getElementById("importFile").addEventListener('change', function(e) { var resultDiv = document.getElementById("result"); var file = e.target.files[0]; if (!file) return; var options = { openMode: 2 /* incremental loading */, fullRecalc: true, dynamicReferences: false, incrementalCalculation: true }; try { if (isSJSFile(file)) { spread.open(file, function() { resultDiv.innerHTML = '<div class="success">File imported successfully!</div>'; setTimeout(function() { resultDiv.innerHTML = ''; }, 2000); }, function(error) { resultDiv.innerHTML = '<div class="error">Error importing file: ' + (error.errorMessage || error.message) + '</div>'; }, options); } else { spread.import(file, function() { resultDiv.innerHTML = '<div class="success">File imported successfully!</div>'; setTimeout(function() { resultDiv.innerHTML = ''; }, 2000); }, function(error) { resultDiv.innerHTML = '<div class="error">Error importing file: ' + (error.errorMessage || error.message) + '</div>'; }, options); } } catch (error) { resultDiv.innerHTML = '<div class="error">Error importing file: ' + error.message + '</div>'; } // Reset input e.target.value = ''; }); // Export file document.getElementById("exportBtn").addEventListener('click', function() { var resultDiv = document.getElementById("result"); var format = document.getElementById("exportFormat").value; try { var fileName = "export." + format; if (format === "sjs") { spread.save(function(blob) { saveAs(blob, fileName); resultDiv.innerHTML = '<div class="success">File exported successfully!</div>'; setTimeout(function() { resultDiv.innerHTML = ''; }, 2000); }, function(error) { resultDiv.innerHTML = '<div class="error">Error exporting file: ' + (error.errorMessage || error.message) + '</div>'; }); } else { var options = { fileType: format === "ssjson" ? GC.Spread.Sheets.FileType.ssjson : GC.Spread.Sheets.FileType.excel }; spread.export(function(blob) { saveAs(blob, fileName); resultDiv.innerHTML = '<div class="success">File exported successfully!</div>'; setTimeout(function() { resultDiv.innerHTML = ''; }, 2000); }, function(error) { resultDiv.innerHTML = '<div class="error">Error exporting file: ' + (error.errorMessage || error.message) + '</div>'; }, options); } } catch (error) { resultDiv.innerHTML = '<div class="error">Error exporting file: ' + error.message + '</div>'; } }); // Calculation mode change var calcModeRadios = document.querySelectorAll('input[name="calcMode"]'); calcModeRadios.forEach(function(radio) { radio.addEventListener('change', function() { var mode = parseInt(this.value); var resultDiv = document.getElementById("result"); spread.options.calculationMode = mode; if (mode === 0) { spread.calculate(); resultDiv.innerHTML = '<div class="success">Calculation mode changed to: Automatic</div>'; } else if (mode === 2 /* partial */) { // this will calc formulas except for data table spread.suspendCalcService(); spread.resumeCalcService(); resultDiv.innerHTML = '<div class="success">Calculation mode changed to: Partial</div>'; } else if (mode === 1) { resultDiv.innerHTML = '<div class="success">Calculation mode changed to: Manual</div>'; } setTimeout(function() { resultDiv.innerHTML = ''; }, 2000); }); }); // Calculate Now button document.getElementById("calculateBtn").addEventListener('click', function() { var resultDiv = document.getElementById("result"); try { spread.calculate(); resultDiv.innerHTML = '<div class="success">Calculation completed!</div>'; setTimeout(function() { resultDiv.innerHTML = ''; }, 2000); } catch (error) { resultDiv.innerHTML = '<div class="error">Error calculating: ' + error.message + '</div>'; } }); }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-calc-worker/dist/gc.spread.sheets.calcworker.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-io/dist/gc.spread.sheets.io.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/datatable.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/FileSaver.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div class="spreadsheet-container"> <div id="ss" class="sample-spreadsheets"></div> <div id="statusBar" class="status-bar"></div> </div> <div class="options-container"> <div class="option-row"> <label>Import / Export:</label> <input type="file" id="importFile" accept=".ssjson,.sjs,.json,.xlsx" style="display:none" /> <input type="button" value="Import File" id="importBtn" /> <label for="exportFormat" style="margin-top: 8px;">Export Format:</label> <select id="exportFormat"> <option value="ssjson">SSJSON</option> <option value="sjs">SJS</option> <option value="xlsx">Excel (XLSX)</option> </select> <input type="button" value="Export File" id="exportBtn" /> </div> <div class="option-row"> <label>Calculation Mode:</label> <div class="radio-group"> <label class="radio-label"> <input type="radio" name="calcMode" value="0" checked /> Automatic </label> <label class="radio-label"> <input type="radio" name="calcMode" value="2" /> Partial </label> <label class="radio-label"> <input type="radio" name="calcMode" value="1" /> Manual </label> </div> <input type="button" value="Calculate Now" id="calculateBtn" /> </div> <div class="option-row"> <label>Result:</label> <div id="result" class="result-container"></div> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .spreadsheet-container { width: calc(100% - 280px); height: 100%; float: left; display: flex; flex-direction: column; } .sample-spreadsheets { flex: 1; overflow: hidden; } .status-bar { height: 30px; border-top: 1px solid #ccc; } .options-container { float: right; width: 280px; overflow: auto; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; } .option-row { margin-bottom: 12px; } .option-row label { display: block; margin-bottom: 4px; font-weight: bold; font-size: 12px; } .description { font-size: 12px; color: #555; line-height: 1.4; margin: 0 0 8px 0; } .description-small { font-size: 11px; color: #666; line-height: 1.3; margin: 0 0 6px 0; } select { width: 100%; padding: 6px; margin-bottom: 6px; border: 1px solid #ccc; border-radius: 3px; box-sizing: border-box; font-size: 12px; } input[type=button] { width: 100%; padding: 8px 6px; margin-bottom: 6px; background: #007acc; color: white; border: none; border-radius: 3px; cursor: pointer; font-weight: bold; } input[type=button]:hover { background: #005a9e; } input[type=button].secondary-button { background: #6c757d; } input[type=button].secondary-button:hover { background: #545b62; } .result-container { padding: 8px; border-radius: 3px; min-height: 40px; } .success { background: #d4edda; color: #155724; padding: 8px; border-radius: 3px; } .error { background: #f8d7da; color: #721c24; padding: 8px; border-radius: 3px; } .radio-group { margin-bottom: 8px; } .radio-label { display: block; font-weight: normal; font-size: 12px; margin-bottom: 4px; cursor: pointer; } .radio-label input[type="radio"] { margin-right: 6px; cursor: pointer; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

SpreadJS add the function SJS.TABLE to get the What-If Analysis Data Table results.
The SJS.TABLE function simulates inputting the value from inputs into input_cell , and then retrieves the value from result reference as the SJS.TABLE function result.
Argument
Description
result_reference
The cell location to retrieve the value. When all inputs are rows, it can be a range of 1 row and multiple columns. vice versa.
inputs
The values to input into input_cell. It can be a reference, an array, or a value.
input_cell
The cell to input the value. Must be a cell reference.
SJS.TABLE can completely cover traditional Data Table
Scenario
Traditional Data Table
Use SJS.TABLE
one-variable data table
Create DataTable A2:C10with column cell reference A2
B3: =SJS.TABLE(B2:C2,A3:A10,A2)
one-variable data table
Create DataTable A2:H5with row cell reference A2
B3: =SJS.TABLE(A3:A5,B2:H2,A2)
two-variable data table
Create DataTable A2:H5 with column cellreference A1 and row cell reference B1
B3: =SJS.TABLE(A2,B2:H2,B1,A3:A5,A1)
The What-If Analysis Data Table from Excel file will be transformed to SJS.TABLE function formula when importing.
When exporting to Excel, it attempts to convert to an Excel data table; if this fails, the formulas will be preserved.
SJS.TABLE is flexible
SJS.TABLE can use the various input
SJS.TABLE can use as the function parameter
import { Component, NgModule, enableProdMode, ViewChild, ElementRef } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { FormsModule } from '@angular/forms';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-calc-worker';
import './styles.css';
function isSJSFile(file: File): boolean {
const fileName = file.name.toLowerCase();
return fileName.endsWith('.sjs');
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
@ViewChild('fileInput') fileInput!: ElementRef;
@ViewChild('statusBar') statusBarElement!: ElementRef;
spread: GC.Spread.Sheets.Workbook;
result: string = '';
resultClass: string = '';
calcMode: string = '0';
exportFormat: string = 'ssjson';
hostStyle = {
width: '100%',
height: '100%'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
// Add status bar
setTimeout(() => {
if (this.statusBarElement) {
const statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(this.statusBarElement.nativeElement);
statusBar.bind(this.spread);
}
});
// Load data from datatable.js
this.spread.fromJSON((window as any).datatable);
}
handleImport() {
this.fileInput.nativeElement.click();
}
handleFileChange($event: any) {
const file = $event.target.files[0];
if (!file) return;
const options = {
openMode: 2, // incremental loading
fullRecalc: true,
dynamicReferences: false,
incrementalCalculation: true
};
try {
if (isSJSFile(file)) {
this.spread.open(file, () => {
this.result = 'File imported successfully!';
this.resultClass = 'success';
setTimeout(() => {
this.result = '';
this.resultClass = '';
}, 2000);
}, (error: any) => {
this.result = 'Error importing file: ' + (error.errorMessage || error.message);
this.resultClass = 'error';
}, options);
} else {
this.spread.import(file, () => {
this.result = 'File imported successfully!';
this.resultClass = 'success';
setTimeout(() => {
this.result = '';
this.resultClass = '';
}, 2000);
}, (error: any) => {
this.result = 'Error importing file: ' + (error.errorMessage || error.message);
this.resultClass = 'error';
}, options);
}
} catch (error: any) {
this.result = 'Error importing file: ' + error.message;
this.resultClass = 'error';
}
$event.target.value = '';
}
handleExport() {
try {
const fileName = "export." + this.exportFormat;
if (this.exportFormat === "sjs") {
this.spread.save((blob: Blob) => {
const url = URL.createObjectURL(blob);
const a = document.createElement('a');
a.href = url;
a.download = fileName;
a.click();
URL.revokeObjectURL(url);
this.result = 'File exported successfully!';
this.resultClass = 'success';
setTimeout(() => {
this.result = '';
this.resultClass = '';
}, 2000);
}, (error: any) => {
this.result = 'Error exporting file: ' + (error.errorMessage || error.message);
this.resultClass = 'error';
});
} else {
const options = { fileType: this.exportFormat === "ssjson" ? GC.Spread.Sheets.FileType.ssjson : GC.Spread.Sheets.FileType.excel };
this.spread.export((blob: Blob) => {
const url = URL.createObjectURL(blob);
const a = document.createElement('a');
a.href = url;
a.download = fileName;
a.click();
URL.revokeObjectURL(url);
this.result = 'File exported successfully!';
this.resultClass = 'success';
setTimeout(() => {
this.result = '';
this.resultClass = '';
}, 2000);
}, (error: any) => {
this.result = 'Error exporting file: ' + (error.errorMessage || error.message);
this.resultClass = 'error';
}, options);
}
} catch (error: any) {
this.result = 'Error exporting file: ' + error.message;
this.resultClass = 'error';
}
}
handleCalcModeChange() {
const mode = parseInt(this.calcMode);
this.spread.options.calculationMode = mode;
if (mode === 0) {
this.spread.calculate();
this.result = 'Calculation mode changed to: Automatic';
this.resultClass = 'success';
} else if (mode === 2) { // partial - calc formulas except for data table
this.spread.suspendCalcService();
this.spread.resumeCalcService();
this.result = 'Calculation mode changed to: Partial';
this.resultClass = 'success';
} else if (mode === 1) {
this.result = 'Calculation mode changed to: Manual';
this.resultClass = 'success';
}
setTimeout(() => {
this.result = '';
this.resultClass = '';
}, 2000);
}
handleCalculateNow() {
try {
this.spread.calculate();
this.result = 'Calculation completed!';
this.resultClass = 'success';
setTimeout(() => {
this.result = '';
this.resultClass = '';
}, 2000);
} catch (error: any) {
this.result = 'Error calculating: ' + error.message;
this.resultClass = 'error';
}
}
}
@NgModule({
imports: [BrowserModule, FormsModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="$DEMOROOT$/spread/source/data/datatable.js" type="text/javascript"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<div class="spreadsheet-container">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div #statusBar class="status-bar"></div>
</div>
<div class="options-container">
<div class="option-row">
<label>Import / Export:</label>
<input type="file" #fileInput accept=".ssjson,.sjs,.json,.xlsx" style="display:none" (change)="handleFileChange($event)" />
<input type="button" value="Import File" (click)="handleImport()" />
<label for="exportFormat" style="margin-top: 8px;">Export Format:</label>
<select id="exportFormat" [(ngModel)]="exportFormat">
<option value="ssjson">SSJSON</option>
<option value="sjs">SJS</option>
<option value="xlsx">Excel (XLSX)</option>
</select>
<input type="button" value="Export File" (click)="handleExport()" />
</div>
<div class="option-row">
<label>Calculation Mode:</label>
<div class="radio-group">
<label class="radio-label">
<input type="radio" name="calcMode" value="0" [(ngModel)]="calcMode" (change)="handleCalcModeChange()" /> Automatic
</label>
<label class="radio-label">
<input type="radio" name="calcMode" value="2" [(ngModel)]="calcMode" (change)="handleCalcModeChange()" /> Partial
</label>
<label class="radio-label">
<input type="radio" name="calcMode" value="1" [(ngModel)]="calcMode" (change)="handleCalcModeChange()" /> Manual
</label>
</div>
<input type="button" value="Calculate Now" (click)="handleCalculateNow()" />
</div>
<div class="option-row">
<label>Result:</label>
<div class="result-container">
<div [class]="resultClass">{{result}}</div>
</div>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.spreadsheet-container {
width: calc(100% - 280px);
height: 100%;
float: left;
display: flex;
flex-direction: column;
}
.spreadsheet-container > gc-spread-sheets {
flex: 1;
overflow: hidden;
}
.status-bar {
height: 30px;
border-top: 1px solid #ccc;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
margin-bottom: 12px;
}
.option-row label {
display: block;
margin-bottom: 4px;
font-weight: bold;
font-size: 12px;
}
input[type=text],
input[type=number] {
width: 100%;
padding: 6px;
border: 1px solid #ccc;
border-radius: 3px;
box-sizing: border-box;
}
select {
width: 100%;
padding: 6px;
margin-bottom: 6px;
border: 1px solid #ccc;
border-radius: 3px;
box-sizing: border-box;
font-size: 12px;
}
input[type=button] {
width: 100%;
padding: 8px 6px;
margin-bottom: 6px;
background: #007acc;
color: white;
border: none;
border-radius: 3px;
cursor: pointer;
font-weight: bold;
}
input[type=button]:hover {
background: #005a9e;
}
.result-container {
padding: 8px;
border-radius: 3px;
min-height: 40px;
}
.success {
background: #d4edda;
color: #155724;
padding: 8px;
border-radius: 3px;
}
.error {
background: #f8d7da;
color: #721c24;
padding: 8px;
border-radius: 3px;
}
.radio-group {
margin-bottom: 8px;
}
.radio-label {
display: block;
font-weight: normal;
font-size: 12px;
margin-bottom: 4px;
cursor: pointer;
}
.radio-label input[type="radio"] {
margin-right: 6px;
cursor: pointer;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.0-master-2026-05-10-2130/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-io': 'cdn:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-calc-worker': 'cdn:@mescius/spread-sheets-calc-worker/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

SpreadJS add the function SJS.TABLE to get the What-If Analysis Data Table results.
The SJS.TABLE function simulates inputting the value from inputs into input_cell , and then retrieves the value from result reference as the SJS.TABLE function result.
Argument
Description
result_reference
The cell location to retrieve the value. When all inputs are rows, it can be a range of 1 row and multiple columns. vice versa.
inputs
The values to input into input_cell. It can be a reference, an array, or a value.
input_cell
The cell to input the value. Must be a cell reference.
SJS.TABLE can completely cover traditional Data Table
Scenario
Traditional Data Table
Use SJS.TABLE
one-variable data table
Create DataTable A2:C10with column cell reference A2
B3: =SJS.TABLE(B2:C2,A3:A10,A2)
one-variable data table
Create DataTable A2:H5with row cell reference A2
B3: =SJS.TABLE(A3:A5,B2:H2,A2)
two-variable data table
Create DataTable A2:H5 with column cellreference A1 and row cell reference B1
B3: =SJS.TABLE(A2,B2:H2,B1,A3:A5,A1)
The What-If Analysis Data Table from Excel file will be transformed to SJS.TABLE function formula when importing.
When exporting to Excel, it attempts to convert to an Excel data table; if this fails, the formulas will be preserved.
SJS.TABLE is flexible
SJS.TABLE can use the various input
SJS.TABLE can use as the function parameter
<template>
<div class="sample-tutorial">
<div class="spreadsheet-container">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div ref="statusBar" class="status-bar"></div>
</div>
<div class="options-container">
<div class="option-row">
<label>Import / Export:</label>
<input type="file" ref="fileInput" accept=".ssjson,.sjs,.json,.xlsx" style="display:none" @change="handleFileChange" />
<input type="button" value="Import File" @click="handleImport" />
<label for="exportFormat" style="margin-top: 8px;">Export Format:</label>
<select id="exportFormat" v-model="exportFormat">
<option value="ssjson">SSJSON</option>
<option value="sjs">SJS</option>
<option value="xlsx">Excel (XLSX)</option>
</select>
<input type="button" value="Export File" @click="handleExport" />
</div>
<div class="option-row">
<label>Calculation Mode:</label>
<div class="radio-group">
<label class="radio-label">
<input type="radio" name="calcMode" value="0" v-model="calcMode" @change="handleCalcModeChange" /> Automatic
</label>
<label class="radio-label">
<input type="radio" name="calcMode" value="2" v-model="calcMode" @change="handleCalcModeChange" /> Partial
</label>
<label class="radio-label">
<input type="radio" name="calcMode" value="1" v-model="calcMode" @change="handleCalcModeChange" /> Manual
</label>
</div>
<input type="button" value="Calculate Now" @click="handleCalculateNow" />
</div>
<div class="option-row">
<label>Result:</label>
<div class="result-container">
<div :class="resultClass">{{result}}</div>
</div>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue';
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-calc-worker';
import GC from "@mescius/spread-sheets";
import { ref } from 'vue';
function isSJSFile(file) {
const fileName = file.name.toLowerCase();
return fileName.endsWith('.sjs');
}
let mySpread;
let result = ref('');
let resultClass = ref('');
let calcMode = ref('0');
let exportFormat = ref('ssjson');
const fileInput = ref(null);
const statusBar = ref(null);
let initSpread = function (spread) {
mySpread = spread;
// Add status bar
setTimeout(() => {
if (statusBar.value) {
const sb = new GC.Spread.Sheets.StatusBar.StatusBar(statusBar.value);
sb.bind(mySpread);
}
});
// Load data from datatable.js
mySpread.fromJSON(window.datatable);
}
let handleImport = function() {
fileInput.value.click();
}
let handleFileChange = function(e) {
const file = e.target.files[0];
if (!file) return;
const options = {
openMode: 2, // incremental loading
fullRecalc: true,
dynamicReferences: false,
incrementalCalculation: true
};
try {
if (isSJSFile(file)) {
mySpread.open(file, () => {
result.value = 'File imported successfully!';
resultClass.value = 'success';
setTimeout(() => {
result.value = '';
resultClass.value = '';
}, 2000);
}, (error) => {
result.value = 'Error importing file: ' + (error.errorMessage || error.message);
resultClass.value = 'error';
}, options);
} else {
mySpread.import(file, () => {
result.value = 'File imported successfully!';
resultClass.value = 'success';
setTimeout(() => {
result.value = '';
resultClass.value = '';
}, 2000);
}, (error) => {
result.value = 'Error importing file: ' + (error.errorMessage || error.message);
resultClass.value = 'error';
}, options);
}
} catch (error) {
result.value = 'Error importing file: ' + error.message;
resultClass.value = 'error';
}
e.target.value = '';
}
let handleExport = function() {
try {
const fileName = "export." + exportFormat.value;
if (exportFormat.value === "sjs") {
mySpread.save((blob) => {
const url = URL.createObjectURL(blob);
const a = document.createElement('a');
a.href = url;
a.download = fileName;
a.click();
URL.revokeObjectURL(url);
result.value = 'File exported successfully!';
resultClass.value = 'success';
setTimeout(() => {
result.value = '';
resultClass.value = '';
}, 2000);
}, (error) => {
result.value = 'Error exporting file: ' + (error.errorMessage || error.message);
resultClass.value = 'error';
});
} else {
const options = { fileType: exportFormat.value === "ssjson" ? GC.Spread.Sheets.FileType.ssjson : GC.Spread.Sheets.FileType.excel };
mySpread.export((blob) => {
const url = URL.createObjectURL(blob);
const a = document.createElement('a');
a.href = url;
a.download = fileName;
a.click();
URL.revokeObjectURL(url);
result.value = 'File exported successfully!';
resultClass.value = 'success';
setTimeout(() => {
result.value = '';
resultClass.value = '';
}, 2000);
}, (error) => {
result.value = 'Error exporting file: ' + (error.errorMessage || error.message);
resultClass.value = 'error';
}, options);
}
} catch (error) {
result.value = 'Error exporting file: ' + error.message;
resultClass.value = 'error';
}
}
let handleCalcModeChange = function() {
const mode = parseInt(calcMode.value);
mySpread.options.calculationMode = mode;
if (mode === 0) {
mySpread.calculate();
result.value = 'Calculation mode changed to: Automatic';
resultClass.value = 'success';
} else if (mode === 2) { // partial - calc formulas except for data table
mySpread.suspendCalcService();
mySpread.resumeCalcService();
result.value = 'Calculation mode changed to: Partial';
resultClass.value = 'success';
} else if (mode === 1) {
result.value = 'Calculation mode changed to: Manual';
resultClass.value = 'success';
}
setTimeout(() => {
result.value = '';
resultClass.value = '';
}, 2000);
}
let handleCalculateNow = function() {
try {
mySpread.calculate();
result.value = 'Calculation completed!';
resultClass.value = 'success';
setTimeout(() => {
result.value = '';
resultClass.value = '';
}, 2000);
} catch (error) {
result.value = 'Error calculating: ' + error.message;
resultClass.value = 'error';
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.spreadsheet-container {
width: calc(100% - 280px);
height: 100%;
float: left;
display: flex;
flex-direction: column;
}
.sample-spreadsheets {
flex: 1;
overflow: hidden;
}
.status-bar {
height: 30px;
border-top: 1px solid #ccc;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
margin-bottom: 12px;
}
.option-row label {
display: block;
margin-bottom: 4px;
font-weight: bold;
font-size: 12px;
}
.description {
font-size: 12px;
color: #555;
line-height: 1.4;
margin: 0 0 8px 0;
}
.description-small {
font-size: 11px;
color: #666;
line-height: 1.3;
margin: 0 0 6px 0;
}
select {
width: 100%;
padding: 6px;
margin-bottom: 6px;
border: 1px solid #ccc;
border-radius: 3px;
box-sizing: border-box;
font-size: 12px;
}
input[type=button] {
width: 100%;
padding: 8px 6px;
margin-bottom: 6px;
background: #007acc;
color: white;
border: none;
border-radius: 3px;
cursor: pointer;
font-weight: bold;
}
input[type=button]:hover {
background: #005a9e;
}
input[type=button].secondary-button {
background: #6c757d;
}
input[type=button].secondary-button:hover {
background: #545b62;
}
.result-container {
padding: 8px;
border-radius: 3px;
min-height: 40px;
}
.success {
background: #d4edda;
color: #155724;
padding: 8px;
border-radius: 3px;
}
.error {
background: #f8d7da;
color: #721c24;
padding: 8px;
border-radius: 3px;
}
.radio-group {
margin-bottom: 8px;
}
.radio-label {
display: block;
font-weight: normal;
font-size: 12px;
margin-bottom: 4px;
cursor: pointer;
}
.radio-label input[type="radio"] {
margin-right: 6px;
cursor: pointer;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="$DEMOROOT$/spread/source/data/datatable.js" type="text/javascript"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-io': 'cdn:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-calc-worker': 'cdn:@mescius/spread-sheets-calc-worker/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

SpreadJS add the function SJS.TABLE to get the What-If Analysis Data Table results.
The SJS.TABLE function simulates inputting the value from inputs into input_cell , and then retrieves the value from result reference as the SJS.TABLE function result.
Argument
Description
result_reference
The cell location to retrieve the value. When all inputs are rows, it can be a range of 1 row and multiple columns. vice versa.
inputs
The values to input into input_cell. It can be a reference, an array, or a value.
input_cell
The cell to input the value. Must be a cell reference.
SJS.TABLE can completely cover traditional Data Table
Scenario
Traditional Data Table
Use SJS.TABLE
one-variable data table
Create DataTable A2:C10with column cell reference A2
B3: =SJS.TABLE(B2:C2,A3:A10,A2)
one-variable data table
Create DataTable A2:H5with row cell reference A2
B3: =SJS.TABLE(A3:A5,B2:H2,A2)
two-variable data table
Create DataTable A2:H5 with column cellreference A1 and row cell reference B1
B3: =SJS.TABLE(A2,B2:H2,B1,A3:A5,A1)
The What-If Analysis Data Table from Excel file will be transformed to SJS.TABLE function formula when importing.
When exporting to Excel, it attempts to convert to an Excel data table; if this fails, the formulas will be preserved.
SJS.TABLE is flexible
SJS.TABLE can use the various input
SJS.TABLE can use as the function parameter
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-calc-worker';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
const useState = React.useState;
const useRef = React.useRef;
function isSJSFile(file) {
const fileName = file.name.toLowerCase();
return fileName.endsWith('.sjs');
}
export function AppFunc() {
const [spread, setSpread] = useState(null);
const [result, setResult] = useState('');
const [resultClass, setResultClass] = useState('');
const [calcMode, setCalcMode] = useState(0);
const [exportFormat, setExportFormat] = useState('ssjson');
const fileInputRef = useRef(null);
const initSpread = (spread) => {
setSpread(spread);
// Add status bar
const statusBar = new GC.Spread.Sheets.StatusBar.StatusBar(document.getElementById('statusBar'));
statusBar.bind(spread);
// Load data from datatable.js
spread.fromJSON(window.datatable);
}
const handleImport = () => {
fileInputRef.current.click();
}
const handleFileChange = (e) => {
const file = e.target.files[0];
if (!file) return;
const options = {
openMode: 2, // incremental loading
fullRecalc: true,
dynamicReferences: false,
incrementalCalculation: true
};
try {
if (isSJSFile(file)) {
spread.open(file, () => {
setResult('File imported successfully!');
setResultClass('success');
setTimeout(() => {
setResult('');
setResultClass('');
}, 2000);
}, (error) => {
setResult('Error importing file: ' + (error.errorMessage || error.message));
setResultClass('error');
}, options);
} else {
spread.import(file, () => {
setResult('File imported successfully!');
setResultClass('success');
setTimeout(() => {
setResult('');
setResultClass('');
}, 2000);
}, (error) => {
setResult('Error importing file: ' + (error.errorMessage || error.message));
setResultClass('error');
}, options);
}
} catch (error) {
setResult('Error importing file: ' + error.message);
setResultClass('error');
}
e.target.value = '';
}
const handleExport = () => {
try {
const fileName = "export." + exportFormat;
if (exportFormat === "sjs") {
spread.save((blob) => {
const url = URL.createObjectURL(blob);
const a = document.createElement('a');
a.href = url;
a.download = fileName;
a.click();
URL.revokeObjectURL(url);
setResult('File exported successfully!');
setResultClass('success');
setTimeout(() => {
setResult('');
setResultClass('');
}, 2000);
}, (error) => {
setResult('Error exporting file: ' + (error.errorMessage || error.message));
setResultClass('error');
});
} else {
const options = { fileType: exportFormat === "ssjson" ? GC.Spread.Sheets.FileType.ssjson : GC.Spread.Sheets.FileType.excel };
spread.export((blob) => {
const url = URL.createObjectURL(blob);
const a = document.createElement('a');
a.href = url;
a.download = fileName;
a.click();
URL.revokeObjectURL(url);
setResult('File exported successfully!');
setResultClass('success');
setTimeout(() => {
setResult('');
setResultClass('');
}, 2000);
}, (error) => {
setResult('Error exporting file: ' + (error.errorMessage || error.message));
setResultClass('error');
}, options);
}
} catch (error) {
setResult('Error exporting file: ' + error.message);
setResultClass('error');
}
}
const handleCalcModeChange = (mode) => {
setCalcMode(mode);
if (spread) {
spread.options.calculationMode = mode;
if (mode === 0) {
spread.calculate();
setResult('Calculation mode changed to: Automatic');
setResultClass('success');
} else if (mode === 2) { // partial - calc formulas except for data table
spread.suspendCalcService();
spread.resumeCalcService();
setResult('Calculation mode changed to: Partial');
setResultClass('success');
} else if (mode === 1) {
setResult('Calculation mode changed to: Manual');
setResultClass('success');
}
setTimeout(() => {
setResult('');
setResultClass('');
}, 2000);
}
}
const handleCalculateNow = () => {
try {
if (spread) {
spread.calculate();
setResult('Calculation completed!');
setResultClass('success');
setTimeout(() => {
setResult('');
setResultClass('');
}, 2000);
}
} catch (error) {
setResult('Error calculating: ' + error.message);
setResultClass('error');
}
}
return <div className="sample-tutorial">
<div className="sample-container">
<div className="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<div id="statusBar"></div>
</div>
<Panel
result={result}
resultClass={resultClass}
calcMode={calcMode}
exportFormat={exportFormat}
setExportFormat={setExportFormat}
fileInputRef={fileInputRef}
handleImport={handleImport}
handleExport={handleExport}
handleFileChange={handleFileChange}
handleCalcModeChange={handleCalcModeChange}
handleCalculateNow={handleCalculateNow}
/>
</div>;
}
function Panel(props) {
return (
<div className="options-container">
<div className="option-row">
<label>Import / Export:</label>
<input type="file" ref={props.fileInputRef} accept=".ssjson,.sjs,.json,.xlsx" style={{display: 'none'}} onChange={props.handleFileChange} />
<input type="button" value="Import File" onClick={props.handleImport} />
<label htmlFor="exportFormat" style={{marginTop: '8px'}}>Export Format:</label>
<select id="exportFormat" value={props.exportFormat} onChange={(e) => props.setExportFormat(e.target.value)}>
<option value="ssjson">SSJSON</option>
<option value="sjs">SJS</option>
<option value="xlsx">Excel (XLSX)</option>
</select>
<input type="button" value="Export File" onClick={props.handleExport} />
</div>
<div className="option-row">
<label>Calculation Mode:</label>
<div className="radio-group">
<label className="radio-label">
<input type="radio" name="calcMode" value="0" checked={props.calcMode === 0} onChange={() => props.handleCalcModeChange(0)} /> Automatic
</label>
<label className="radio-label">
<input type="radio" name="calcMode" value="2" checked={props.calcMode === 2} onChange={() => props.handleCalcModeChange(2)} /> Partial
</label>
<label className="radio-label">
<input type="radio" name="calcMode" value="1" checked={props.calcMode === 1} onChange={() => props.handleCalcModeChange(1)} /> Manual
</label>
</div>
<input type="button" value="Calculate Now" onClick={props.handleCalculateNow} />
</div>
<div className="option-row">
<label>Result:</label>
<div className="result-container">
<div className={props.resultClass}>{props.result}</div>
</div>
</div>
</div>
)
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="$DEMOROOT$/spread/source/data/datatable.js" type="text/javascript"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-container {
width: calc(100% - 280px);
height: 100%;
float: left;
}
.sample-spreadsheets {
width: 100%;
height: calc(100% - 25px);
overflow: hidden;
}
#statusBar {
bottom: 0;
height: 25px;
width: 100%;
position: relative;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
margin-bottom: 12px;
}
.option-row label {
display: block;
margin-bottom: 4px;
font-weight: bold;
font-size: 12px;
}
input[type=text],
input[type=number] {
width: 100%;
padding: 6px;
border: 1px solid #ccc;
border-radius: 3px;
box-sizing: border-box;
}
select {
width: 100%;
padding: 6px;
margin-bottom: 6px;
border: 1px solid #ccc;
border-radius: 3px;
box-sizing: border-box;
font-size: 12px;
}
input[type=button] {
width: 100%;
padding: 8px 6px;
margin-bottom: 6px;
background: #007acc;
color: white;
border: none;
border-radius: 3px;
cursor: pointer;
font-weight: bold;
}
input[type=button]:hover {
background: #005a9e;
}
.result-container {
padding: 8px;
border-radius: 3px;
min-height: 40px;
}
.success {
background: #d4edda;
color: #155724;
padding: 8px;
border-radius: 3px;
}
.error {
background: #f8d7da;
color: #721c24;
padding: 8px;
border-radius: 3px;
}
.radio-group {
margin-bottom: 8px;
}
.radio-label {
display: block;
font-weight: normal;
font-size: 12px;
margin-bottom: 4px;
cursor: pointer;
}
.radio-label input[type="radio"] {
margin-right: 6px;
cursor: pointer;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.1-master-2026-05-28-1420/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-io': 'cdn:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-calc-worker': 'cdn:@mescius/spread-sheets-calc-worker/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);